# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Fabio Massaioli fabio.massaioli@virgilio.it
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

from gi.repository import Gtk, GLib

def error_msg(window, main_text, secondary_text, title="Lockbox"):
    msg = Gtk.MessageDialog(window, Gtk.DialogFlags.MODAL, Gtk.MessageType.ERROR,
                            Gtk.ButtonsType.OK, main_text)
    msg.format_secondary_text(secondary_text)
    msg.set_title(title)
    msg.run()
    msg.destroy()
    del msg

def info_msg(window, main_text, secondary_text, title="Lockbox"):
    msg = Gtk.MessageDialog(window, Gtk.DialogFlags.MODAL, Gtk.MessageType.INFO,
                            Gtk.ButtonsType.OK, main_text)
    msg.format_secondary_text(secondary_text)
    msg.set_title(title)
    msg.run()
    msg.destroy()
    del msg

def warning_question(window, main_text, secondary_text, title="Lockbox"):
    msg = Gtk.MessageDialog(window, Gtk.DialogFlags.MODAL, Gtk.MessageType.WARNING,
                            Gtk.ButtonsType.YES_NO, main_text)
    msg.format_secondary_text(secondary_text)
    msg.set_title(title)
    result = msg.run()
    msg.destroy()
    del msg
    return result

def process_activity_dialog_delete_event(widget, event):
    
    return True

def process_activity_dialog_timeout(data):
    pbar = data[0]
    dlg = data[1]
    op_thread = data[2]
    
    pbar.pulse()
    if not op_thread.is_alive():
        print("Thread finished")
        dlg.destroy()
        return False
    
    return True

def process_activity_dialog(window, main_text, secondary_text, op_thread, title="Lockbox"):
    msg = Gtk.MessageDialog(window, Gtk.DialogFlags.MODAL, Gtk.MessageType.OTHER,
                            Gtk.ButtonsType.NONE, main_text)
    msg.format_secondary_text(secondary_text)
    msg.connect('delete-event', process_activity_dialog_delete_event)
    msg.set_title(title)
    pbar = Gtk.ProgressBar()
    pbar.set_pulse_step(0.02)
    msg.get_message_area().pack_end(pbar, True, False, 0)

    pbar.show()

    if window != None: window.process_activity_dialog = msg
    op_thread.start()

    tcode = GLib.timeout_add(100, process_activity_dialog_timeout, (pbar, msg, op_thread))

    msg.run()

    GLib.source_remove(tcode)
    msg.destroy()

